#include "Bot.h"

using namespace std;

#define Infinity 1000000

//constructor
Bot::Bot()
{

};

//plays a single game of Ants.
void Bot::playGame()
{
    //reads the game parameters and sets up
    cin >> state;
    state.setup();
    endTurn();

	hill0.Resize(state.rows, state.cols);
	hill1.Resize(state.rows, state.cols);
	food.Resize(state.rows, state.cols);
	ant0.Resize(state.rows, state.cols);
	chk0.Resize(state.rows, state.cols);

	//continues making moves while the game is not over
    while(cin >> state)
    {
        state.updateVisionInformation();
        makeMoves();
        endTurn();
    }
};

int RandCompare(const void *a, const void *b)
{
	return rand()%3-1;
}

//makes the bots moves for the turn
void Bot::makeMoves()
{
	// Hill
	hill0.Fill(Infinity);

	while( !q0.empty() )
		q0.pop();

	for(int i = 0; i < state.myHills.size(); i++)
	{
		q0.push(state.myHills[i]);
		hill0(state.myHills[i].row, state.myHills[i].col) = 0;
	}

	while( !q0.empty() )
	{
		Location curr = q0.front();
		q0.pop();
		int currW = hill0(curr.row,curr.col);
		//if( currW > 5*sqrt((double)(state.myAnts.size())) ) break;

		for(int i = 0; i < TDIRECTIONS; i++)
		{
			Location next = state.getLocation(curr, i);

			if( hill0(next.row,next.col) == Infinity && !state.grid[next.row][next.col].isWater )
			{
				hill0(next.row,next.col) = currW - 1;
				q0.push(next);
			}
		}
	}

	hill1.Fill(Infinity);

	while( !q0.empty() )
		q0.pop();

	for(int i = 0; i < state.enemyHills.size(); i++)
	{
		q0.push(state.enemyHills[i]);
		hill1(state.enemyHills[i].row, state.enemyHills[i].col) = 0;
	}

	while( !q0.empty() )
	{
		Location curr = q0.front();
		q0.pop();
		int currW = hill1(curr.row,curr.col);
		//if( currW > 2*state.viewradius ) break;

		for(int i = 0; i < TDIRECTIONS; i++)
		{
			Location next = state.getLocation(curr, i);

			if( hill1(next.row,next.col) == Infinity && !state.grid[next.row][next.col].isWater )
			{
				hill1(next.row,next.col) = 1 + currW;
				q0.push(next);
			}
		}
	}

	// Food
	food.Fill(Infinity);

	while( !q0.empty() )
		q0.pop();

	for(int i = 0; i < state.food.size(); i++)
	{
		q0.push(state.food[i]);
		food(state.food[i].row, state.food[i].col) = 0;
	}

	while( !q0.empty() )
	{
		Location curr = q0.front();
		q0.pop();
		int currW = food(curr.row,curr.col);
		//if( currW > 2*state.viewradius ) break;

		for(int i = 0; i < TDIRECTIONS; i++)
		{
			Location next = state.getLocation(curr, i);

			if( food(next.row,next.col) == Infinity && !state.grid[next.row][next.col].isWater )
			{
				food(next.row,next.col) = 1 + currW;
				q0.push(next);
			}
		}
	}

	// Check
	chk0.Fill(0);
	for(int i = 0; i < state.myAnts.size(); i++)
		chk0(state.myAnts[i].row, state.myAnts[i].col) = 1;

	int w[3] = {5, 2, 4}; // Curr
	//int w[3] = {0, 0, 0}; // food, explore, hunt
	//int w[3] = {5, 2, 4}; // Food + Hunt
	//int w[3] = {3, 1, 2}; // Home2
	//int w[3] = {5, 0, 3}; // Home
	//int w[3] = {5, 2, 3}; // Food

    for(int ant=0; ant<(int)state.myAnts.size(); ant++)
    {
		int tmp[4] = {0, 1, 2, 3};
		qsort(tmp, 4, sizeof(tmp[0]), RandCompare);

		int min = Infinity;
		int minDir = -1;

		Location minLoc = state.myAnts[ant];

		for(int i = 0; i < 4; i++)
		{
			//int d = i;
			int d = tmp[i];
			Location loc = state.getLocation(state.myAnts[ant], d);
			int weight = w[0]*food(loc.row, loc.col) + w[1]*hill0(loc.row, loc.col) + w[2]*hill1(loc.row, loc.col);
			//int weight = 5*food(loc.row, loc.col) + 1*hill0(loc.row, loc.col) + 4*hill1(loc.row, loc.col); // Food + Hunt
			//int weight = 3*food(loc.row, loc.col) + 1*hill0(loc.row, loc.col) + 2*hill1(loc.row, loc.col); // Home2
			//int weight = 5*food(loc.row, loc.col) + 0*hill0(loc.row, loc.col) + 3*hill1(loc.row, loc.col); // Home
			//int weight = 5*food(loc.row, loc.col) + 2*hill0(loc.row, loc.col) + 3*hill1(loc.row, loc.col); // Food
			//int weight = hill(loc.row, loc.col);
			//int weight = food(loc.row, loc.col);

			if( !state.grid[loc.row][loc.col].isWater && chk0(loc.row, loc.col) == 0 && (minDir < 0 || weight < min) )
			{
				min = weight;
				minDir = d;
				minLoc = loc;
			}
		}
		
		if( minDir >= 0 )
		{
			state.makeMove(state.myAnts[ant], minDir);
			chk0(minLoc.row, minLoc.col) = 1;
		}
    }
};

//finishes the turn
void Bot::endTurn()
{
    if(state.turn > 0)
        state.reset();
    state.turn++;

    cout << "go" << endl;
};
