#ifndef BOT_H_
#define BOT_H_

#include "State.h"
#include <vector>
#include <queue>

using namespace std;

/*
    This struct represents your bot in the game of Ants
*/

struct Map
{
	int *data;
	int width;
	int height;
	int size;

	Map() : width(100), height(100)
	{
		size = width * height;
		data = new int[size];
	}

	void Resize(int _w, int _h)
	{
		width = _w;
		height = _h;
		size = width * height;

		delete data;
		data = new int[size];
	}

	void Fill(int value)
	{
		for(int i = 0; i < size; i++)
			data[i] = value;
	}

	inline int& operator ( ) (int col, int row)
	{
		return data[col + row*width];
	}

	inline int operator ( ) (int col, int row) const
	{
		return data[col + row*width];
	}
};

struct Bot
{
    State state;
	Map hill0;
	Map hill1;
	Map food;
	Map ant0;
	Map chk0;
	queue<Location> q0;

    Bot();

    void playGame();    //plays a single game of Ants

    void makeMoves();   //makes moves for a single turn
    void endTurn();     //indicates to the engine that it has made its moves
};

#endif //BOT_H_
